/*
* generated by Xtext
*/
package org.openmodelica.modelicaml.editor.xtext.valuebinding.ui.contentassist;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.*;
import org.openmodelica.modelicaml.editor.xtext.model.ui.contentassist.ModeleditorProposalProvider;
import org.eclipse.xtext.ui.editor.contentassist.ICompletionProposalAcceptor;
import org.eclipse.xtext.ui.editor.contentassist.ContentAssistContext;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.text.contentassist.ICompletionProposal;
import org.eclipse.swt.graphics.Image;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.ui.editor.contentassist.ContentAssistContext;
import org.eclipse.xtext.ui.editor.contentassist.ICompletionProposalAcceptor;
import org.openmodelica.modelicaml.common.constants.Constants;
import org.openmodelica.modelicaml.common.contentassist.ModelicaMLContentAssist;
import org.openmodelica.modelicaml.common.utls.SWTResourceManager;
/**
 * Represents a generated, default implementation of interface {@link IProposalProvider}.
 * Methods are dynamically dispatched on the first parameter, i.e., you can override them 
 * with a more concrete subtype. 
 */
@SuppressWarnings("all")
public class AbstractProviderProposalProvider extends ModeleditorProposalProvider {
	
	
	@Override
	public void complete_component_reference(EObject model, RuleCall ruleCall, ContentAssistContext context, ICompletionProposalAcceptor acceptor)
	{
		super.complete_component_reference(model, ruleCall, context, acceptor);
		
		List<String> cList = ModelicaMLContentAssist.getComponentReferenceSortedList();
		
		for (String string : cList) {
			// replace the Value Provider component name with a specific macro
			if (string.startsWith(ModelicaMLContentAssist.getPropertyName())) {
				string = string.replaceFirst(ModelicaMLContentAssist.getPropertyName(), Constants.MACRO_providerPath);
			}
			
			String completionString = string;
			String displayString = ModelicaMLContentAssist.getDisplayCompletionString(context.getPrefix(), completionString);

			Image image = ModelicaMLContentAssist.getIcon(string);
			if (image == null) {
				image = SWTResourceManager.getImage(SWTResourceManager.class, "/icons/valueMediator.png");
			}
			
			ICompletionProposal completionProposal = createCompletionProposal(completionString, displayString, image, context);

			acceptor.accept(completionProposal);
		}
	}
	
//	OLD: //String displayString = string.replaceFirst(context.getPrefix(), "");
//	NEW: String displayString = ModelicaMLContentAssist.getDisplayCompletionString(context.getPrefix(), completionString);

		
	@Override
	public void complete_name(EObject model, RuleCall ruleCall, ContentAssistContext context, ICompletionProposalAcceptor acceptor){
		super.complete_name(model, ruleCall, context, acceptor);
		
		List<String> cList = ModelicaMLContentAssist.getComponentReferenceSortedList();
		
		for (String string : cList) {
			// replace the Value Provider component name with a specific macro
			if (string.startsWith(ModelicaMLContentAssist.getPropertyName())) {
				string = string.replaceFirst(ModelicaMLContentAssist.getPropertyName(), Constants.MACRO_providerPath);
			}
			
			String completionString = string;
			String displayString = ModelicaMLContentAssist.getDisplayCompletionString(context.getPrefix(), completionString);

			Image image = ModelicaMLContentAssist.getIcon(string);
			if (image == null) {
				image = SWTResourceManager.getImage(SWTResourceManager.class, "/icons/valueMediator.png");
			}
			
			ICompletionProposal completionProposal = createCompletionProposal(completionString, displayString, image, context);
			
			acceptor.accept(completionProposal);
		}
	}
	
//	public void completeProviderOperation_Expr(EObject model, Assignment assignment, ContentAssistContext context, ICompletionProposalAcceptor acceptor) {
//		completeRuleCall(((RuleCall)assignment.getTerminal()), context, acceptor);
//	}
//	public void completeName_Name_ID(EObject model, Assignment assignment, ContentAssistContext context, ICompletionProposalAcceptor acceptor) {
//		completeRuleCall(((RuleCall)assignment.getTerminal()), context, acceptor);
//	}
//	public void completeName_Nam_ID(EObject model, Assignment assignment, ContentAssistContext context, ICompletionProposalAcceptor acceptor) {
//		completeRuleCall(((RuleCall)assignment.getTerminal()), context, acceptor);
//	}
//	public void completeComponent_reference_Ref(EObject model, Assignment assignment, ContentAssistContext context, ICompletionProposalAcceptor acceptor) {
//		completeRuleCall(((RuleCall)assignment.getTerminal()), context, acceptor);
//	}
//	public void completeComponent_reference_Subscripts1(EObject model, Assignment assignment, ContentAssistContext context, ICompletionProposalAcceptor acceptor) {
//		completeRuleCall(((RuleCall)assignment.getTerminal()), context, acceptor);
//	}
//	public void completeComponent_reference_Ref1(EObject model, Assignment assignment, ContentAssistContext context, ICompletionProposalAcceptor acceptor) {
//		completeRuleCall(((RuleCall)assignment.getTerminal()), context, acceptor);
//	}
//	public void completeComponent_reference_Subscripts(EObject model, Assignment assignment, ContentAssistContext context, ICompletionProposalAcceptor acceptor) {
//		completeRuleCall(((RuleCall)assignment.getTerminal()), context, acceptor);
//	}
//    
//	public void complete_ProviderOperation(EObject model, RuleCall ruleCall, ContentAssistContext context, ICompletionProposalAcceptor acceptor) {
//		// subclasses may override
//	}

}
