package org.openmodelica.modelicaml.simulation.testexecution.actions;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PlatformUI;
import org.openmodelica.modelicaml.simulation.testexecution.dialogs.DialogMessageWithHTMLBrowser;

public class OpenTestExecutionReportAction implements
		IWorkbenchWindowActionDelegate {

	private String reportFileAbsolutePath = null;
	
	

	public void setReportFilePath(String path){
		this.reportFileAbsolutePath = path;
	}
	
	@Override
	public void run(IAction action) {
		if (this.reportFileAbsolutePath == null) {
			ISelection selection = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getSelectionService().getSelection();
			if(selection instanceof IStructuredSelection) {
				Object firstElement = ((IStructuredSelection)selection).getFirstElement();
				if (firstElement instanceof IFile) {
					this.reportFileAbsolutePath = ((IFile)firstElement).getLocationURI().toString().replaceFirst("file:\\/", "");
				}
			}
		}
		
		if (this.reportFileAbsolutePath != null) {
			//DialogMessageWithHTMLBrowser dialog = new DialogMessageWithHTMLBrowser(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), // don't use this because it will block the window underneath.
			DialogMessageWithHTMLBrowser dialog = new DialogMessageWithHTMLBrowser(new Shell(),
					"Verification Session Report", 
					this.reportFileAbsolutePath + "?enableTool=true");
			dialog.open();
		}
	}

	@Override
	public void selectionChanged(IAction action, ISelection selection) {
		// TODO Auto-generated method stub

	}

	@Override
	public void dispose() {
		// TODO Auto-generated method stub

	}

	@Override
	public void init(IWorkbenchWindow window) {
		// TODO Auto-generated method stub

	}

		
}
